#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int X, Y, Q, temp, tempx, tempy;
    vector<vector<int>> koord;
    vector<int> y;
    vector<tuple<int, int>> q;
    cin >> X >> Y;
    for(int i = 0; i < X; i++)
    {
        for(int j = 0; j < Y; j++)
        {
            cin >> temp;
            y.push_back(temp);

        }
        koord.push_back(y);
        if(i != X - 1)
            y.clear();
    }
    cin >> Q;
    for(int i = 0; i < Q; i++)
    {
        cin >> tempx;
        cin >> tempy;
        q.push_back(make_tuple(tempx, tempy));
    }

    for(int i = 0; i < Q; i++)
    {
        tempx = get<0>(q[i]);
        tempy = get<1>(q[i]);
        int curx = 1, cury = 1, uk = koord[curx - 1][cury - 1];
        while(!(curx == X && cury == Y))
        {
            if(curx == X && cury != Y)
            {
                if(curx == tempx && cury == tempy - 1)
                {
                    uk -= koord[curx - 1][cury - 1];
                    curx--;
                    uk += koord[curx][cury - 1];
                    cury++;
                }
                else
                {
                    uk += koord[curx - 1][cury];
                    cury++;
                }
            }
            else if(cury == Y && curx != X)
            {
                if(cury == tempy && curx == tempx - 1)
                {
                    uk -= koord[curx - 1][cury - 1];
                    cury--;
                    uk += koord[curx][cury - 1];
                    curx++;
                }
                else
                {
                    uk += koord[curx][cury - 1];
                    curx++;
                }
            }
            else if(cury == tempy && curx == tempx - 1)
            {
                uk+= koord[curx - 1][cury];
                cury++;
            }
            else if(curx == tempx && cury == tempy - 1)
            {
                uk+= koord[curx][cury - 1];
                curx++;
            }
            else
            {
                if(koord[curx][cury - 1] >= koord[curx - 1][cury])
                {
                    uk += koord[curx][cury - 1];
                    curx++;
                }
                else
                {
                    uk += koord[curx - 1][cury ];
                    cury++;
                }
            }
        }
        cout << uk;
        if(i != Q - 1)
            cout << "\n";
    }
    return 0;
}